/***********************************************************************************************************
****    Questo e' il file base per i vari plug-in audio, video e
****    della porta di comunicazione per il RascalBoy Advance.
****
****    Si tenga presente che ogni tipo di plug-in ha la sua funzione RunFunc.
****    I vari plug-in in base al tipo saranno accodati al menu' Filtri Audio per il plug-in 
****    audio, menu' Filtri Video per quelli video e nel 
****    menu' Porta di comunicazione quelli della SIO.
****
****
****    Sono liberamente distribuibili senza nessuna riserva o altro vincolo.
****    Per eventuali problemi potete contattarmi 
****    a rascalboy@nzone.it oppure a linoma@inwind.it.
***********************************************************************************************************/

#define INITGUID

#include <windows.h>
#include <ole2.h>
#include "pluginmain.h"

DEFINE_GUID(yourguid, 0x0L, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0);
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
   return 1;
}
//---------------------------------------------------------------------------
//This function is called when the RBA load the plug-in
//---------------------------------------------------------------------------
DWORD __declspec(dllexport) WINAPI GetInfoFunc(LPPLUGININFO p)
{
   p->wType = PIT_AUDIO;
   if(p->pszText != NULL){
       switch(LOWORD(p->dwLanguageID)){
           default:
               lstrcpyn((LPSTR)p->pszText,"Plug-In Name",p->cchTextMax);
           break;
       }
   }
   CopyMemory(&p->guidID,&yourguid,sizeof(GUID));
   return 1;
}
//---------------------------------------------------------------------------
//This function is called when the RBA notify the plug-in the various changes
//---------------------------------------------------------------------------
BOOL __declspec(dllexport) WINAPI SetInfoFunc(LPPLUGININFO p)
{
   BOOL res;

   res = TRUE;
   if((p->dwStateMask & PIS_ENABLEMASK)){
       if(PLUGINISENABLE(p))
        //Plug-in is enabled        
       else
        //Plug-in is disabled
   }
   if(!res)
       return FALSE;
   if((p->dwStateMask & PIS_RUNMASK))
       //Plug-in is run
   if((p->dwStateMask & PIS_VIDEOMODEMASK))
       //The RBA is FullScreen Video Mode
   return res;
}
//---------------------------------------------------------------------------
//
//
// This function is called when the RBA run the plug-in
//
//
//---------------------------------------------------------------------------
// It's the function for SIO plug-in Ver 1.2.7.4
//---------------------------------------------------------------------------
BOOL __declspec(dllexport) WINAPI RunFunc(LPSERIALIO p)
{   
   return TRUE;
}
//---------------------------------------------------------------------------
// It's the function for Video plug-in
//---------------------------------------------------------------------------
BOOL __declspec(dllexport) WINAPI RunFunc(WORD index,unsigned short *InBuffer,unsigned short *OutBuffer);
{
   return TRUE;
}
//---------------------------------------------------------------------------
// It's th function for Audio plug-in
//---------------------------------------------------------------------------
BOOL __declspec(dllexport) WINAPI RunFunc(WORD index,LPVOID mem1,DWORD dwSize1,LPVOID mem2,DWORD dwSize2)
{
   return TRUE;
}
//---------------------------------------------------------------------------
BOOL __declspec(dllexport) WINAPI ResetFunc()
{
    //This function is called when reset the RBA
   return TRUE;
}
//---------------------------------------------------------------------------
BOOL __declspec(dllexport) WINAPI DeleteFunc()
{
    //This function is called when destroy the plug-in  
   return TRUE;
}
//---------------------------------------------------------------------------
BOOL __declspec(dllexport) WINAPI SetPropertyFunc(LPSETPROPPLUGIN p)
{
    //This function is called when the RBA show the Plug-In's PropertyPage
    return TRUE;
}